#include "platform.hpp"

int gameEntry(int argc, char *argv[]);

#if defined(LIERO_WIN32) && !defined(DISABLE_MAINHACK)
// A bit of a hack to avoid DLL dependencies
#define _WIN32_WINDOWS 0x0410
#define WINVER 0x0410
#include <windows.h>
#include <SDL/SDL.h>

#ifdef main
#undef main
#endif
#include <SDL/SDL.h>
int main(int argc, char *argv[])
{
	SDL_SetModuleHandle(GetModuleHandle(NULL));
	
	return gameEntry(argc, argv);
}
#else
#include <SDL/SDL.h>
int main(int argc, char *argv[])
{
	return gameEntry(argc, argv);
}
#endif

#ifdef __SYMBIAN32__
#include <sdl\sdlapp.h>
#include <e32base.h>
#include <eikstart.h>
#include <eikenv.h>
#include <eikapp.h>
#include <eikappui.h>
#include <bautils.h>


class COpenLieroApp : public CSDLApp {
public:
    COpenLieroApp()
	{
	}
	
    ~COpenLieroApp()
	{
	}
	
#if defined (UIQ3)
    /**
     * Returns the resource id to be used to declare the views supported by this UIQ3 app
     * @return TInt, resource id
     */
    TInt ViewResourceId();
#endif
    TUid AppDllUid() const
	{
	return  TUid::Uid(0xA000A002);
	}
};

// this function is called automatically by the SymbianOS to deliver the new CApaApplication object
CApaApplication* NewApplication() {
    // Return pointer to newly created CQMApp
    return new COpenLieroApp;
}
#ifdef UIQ3
#include <Liero.rsg>
#endif
TInt COpenLieroApp::ViewResourceId()
	{
    return R_SDL_VIEW_UI_CONFIGURATIONS;
	}

// E32Main() contains the program's start up code, the entry point for an EXE.
GLDEF_C TInt E32Main() {
    return EikStart::RunApplication(NewApplication);
}
static char gInstallDrive[256] = "z:\\resource\\apps\\liero\\LIERO.EXE";
char* InstallPath()
    {
	RFs& fs = CEikonEnv::Static()->FsSession();
	gInstallDrive[0] = CEikonEnv::Static()->EikAppUi()->Application()->BitmapStoreName()[0];
	TBuf<64> lieroPath = _L("d:\\liero\\liero.exe");
	for(TInt drive = 'd';drive<='f';drive++)
	{
		lieroPath[0] = drive;
		if( BaflUtils::FileExists(fs, lieroPath) ) 
		{
			strcpy(gInstallDrive, "d:\\liero\\liero.exe");
			gInstallDrive[0] = drive;
			break;
		}
	}

    return gInstallDrive;;
    }
#endif
